<script lang="ts">
  import { createActionDispatcher, isActing } from "./actionUtils";
  import CardFront from "./components/CardFront.svelte";
  import Deck from "./components/Deck.svelte";
  import EmptyCardSpot from "./components/EmptyCardSpot.svelte";
  import Chip from "./components/icons/Chip.svelte";
  import PlayerStacks from "./components/PlayerStacks.svelte";
  import Results from "./components/Results.svelte";
  import Speech from "./components/Speech.svelte";
  import { orderPlayers } from "./util";
  import { fade, fly } from "svelte/transition";
  import { send, receive } from "./components/cardCrossfade";
  import Prompt from "./components/Prompt.svelte";

  export let playerId: PlayerId | undefined;
  export let state: GameState;

  /* svelte-ignore unused-export-let */
  export let settings: GameSettings;

  $: user = state.players.find((p) => p.id === playerId) ?? null;

  const dispatchAction = createActionDispatcher();

  $: orderedPlayers = orderPlayers(state.players, playerId);

  $: currentCard = state.card !== null ? [state.card] : [];

  function getPlayerTransform(playerCount: number, idx: number): string {
    let angleStep = (2 * Math.PI) / playerCount;
    let startAngle = 0;
    let angle = startAngle - angleStep * idx;
    let radius = 18 + playerCount;

    let translateX = Math.sin(angle) * radius;
    let translateY = Math.cos(angle) * radius;

    return `
      --player-translate-x: ${translateX.toFixed(2)}em;
      --player-translate-y: ${translateY.toFixed(2)}em;
    `;
  }
</script>

<div class="center">
  <div class="deck">
    <button
      disabled={state.phase.t !== "Draw" ||
        playerId === undefined ||
        !isActing(state.phase, playerId)}
      class="card-button"
      on:click={() => dispatchAction("Draw")}
    >
      <Deck deck={state.deck} size={state.deck.length} />
    </button>
    {#if state.phase.t === "Draw" && playerId !== undefined && isActing(state.phase, playerId)}
      <div class="deck-help-text" in:fly={{ delay: 3000 }} out:fade>
        &uarr; Click deck to reveal card.
      </div>
    {/if}
  </div>
  <div class="card">
    <div class="card-empty-slot">
      <EmptyCardSpot />
    </div>
    {#each currentCard as card (card)}
      <div in:receive={{ key: card }} out:send={{ key: card }}>
        <CardFront value={card} />
      </div>
    {/each}
    {#if state.chips > 0}
      <div class="center-card-chips">
        <Chip /> &times; {state.chips}
      </div>
    {/if}
  </div>
</div>

<div class="players">
  {#each state.players as player (player.id)}
    {@const idx = orderedPlayers.findIndex((p) => p.id === player.id)}
    <div class="player" style={getPlayerTransform(orderedPlayers.length, idx)}>
      <gs6-player-box
        playerid={player.id}
        thinking={isActing(state.phase, player.id)}
        speaking={player.id !== playerId && player.speech}
      >
        {#if player.id === playerId}
          <div class="player-chips">
            <Chip /> × {player.chips}
          </div>
        {/if}

        <div class="player-stacks">
          <PlayerStacks {player} />
        </div>

        {#if player.speech}
          <div class="player-speech" slot="speech">
            <Speech speech={player.speech} />
          </div>
        {/if}

        {#if state.phase.t === "Choose" && user !== null && user.id === player.id && isActing(state.phase, player.id)}
          <div class="player-prompt">
            <Prompt {user} on:action />
          </div>
        {/if}
      </gs6-player-box>
    </div>
  {/each}
</div>

{#if state.phase.t === "GameComplete"}
  <div class="results panel">
    <Results players={state.players} />
  </div>
{/if}

<style>
  .center {
    font-size: 0.75em;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
    display: grid;
    grid-template-columns: 1fr 1fr;
  }
  .deck {
    margin-right: 1em;
    position: relative;
  }

  .card .card-empty-slot {
    position: absolute;
  }

  .center-card-chips {
    position: absolute;
    left: 50%;
    bottom: 0;
    transform: translate(-50%, 100%) translateY(0.5rem);

    font-size: 1.2rem;
    font-weight: 500;
  }

  .players {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
  .player {
    position: absolute;
    transform: translate(-50%, -50%) translateY(-3rem)
      translateX(var(--player-translate-x))
      translateY(var(--player-translate-y));
    transition: transform 0.5s;
  }

  .player-chips {
    font-size: 1.2rem;

    font-weight: 500;
    width: 100%;
    text-align: center;
    white-space: nowrap;
  }
  .player-stacks {
    font-size: 0.3em;
    position: absolute;
    bottom: 1em;
    left: 50%;
    transform: translate(-50%, 100%);
  }
  .player-speech {
    text-align: center;
  }

  button.card-button {
    width: 100%;

    transition: transform 0.25s;

    text-align: inherit;
    line-height: inherit;
    font-size: inherit;
    background-color: inherit;
    border: 0;
    padding: 0;
    cursor: pointer;
  }

  .card-button:disabled {
    color: inherit;
    cursor: inherit;
  }

  .player-prompt {
    position: absolute;
    top: 0;
    left: 50%;
    transform: translate(-50%, -100%) translateY(-1rem);
  }

  .deck-help-text {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 100%);
    white-space: nowrap;
    padding: 0.5em;

    font-size: 1rem;
    font-style: italic;
    font-weight: 300;
  }

  .results {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
